Index: t3lib/class.t3lib_foldertree.php
===================================================================
--- t3lib/class.t3lib_foldertree.php	(Revision 5109)
+++ t3lib/class.t3lib_foldertree.php	(Arbeitskopie)
@@ -55,7 +55,6 @@
  *
  */
 
-require_once (PATH_t3lib.'class.t3lib_treeview.php');
 
 
 
Index: t3lib/class.t3lib_basicfilefunc.php
===================================================================
--- t3lib/class.t3lib_basicfilefunc.php	(Revision 5109)
+++ t3lib/class.t3lib_basicfilefunc.php	(Arbeitskopie)
@@ -67,7 +67,6 @@
  *
  */
 
-require_once(PATH_t3lib.'class.t3lib_cs.php');
 
 
 /**
Index: t3lib/class.t3lib_refindex.php
===================================================================
--- t3lib/class.t3lib_refindex.php	(Revision 5109)
+++ t3lib/class.t3lib_refindex.php	(Arbeitskopie)
@@ -60,10 +60,6 @@
  *
  */
 
-require_once(PATH_t3lib.'class.t3lib_befunc.php');
-require_once(PATH_t3lib.'class.t3lib_tcemain.php');
-require_once(PATH_t3lib.'class.t3lib_flexformtools.php');
-//require_once(PATH_typo3.'sysext/indexed_search/class.lexer.php'); // Disabled until Kasper finishes this feature. Apart from that, t3lib classes should never require stuff from extensions.
 
 
 
Index: t3lib/class.t3lib_syntaxhl.php
===================================================================
--- t3lib/class.t3lib_syntaxhl.php	(Revision 5109)
+++ t3lib/class.t3lib_syntaxhl.php	(Arbeitskopie)
@@ -71,7 +71,6 @@
 
 
 
-require_once(PATH_t3lib.'class.t3lib_parsehtml.php');
 
 
 /**
Index: t3lib/class.t3lib_tceforms.php
===================================================================
--- t3lib/class.t3lib_tceforms.php	(Revision 5109)
+++ t3lib/class.t3lib_tceforms.php	(Arbeitskopie)
@@ -181,16 +181,8 @@
 
 
 
-require_once(PATH_t3lib.'class.t3lib_diff.php');
-require_once(PATH_t3lib.'class.t3lib_tceforms_inline.php');
 
-	/**
-	 * Frontend version of TCEForms has been moved into its own file and should
-	 * be included directly by calling scripts.
-	 */
-require_once(PATH_t3lib . 'class.t3lib_tceforms_fe.php');
 
-
 /**
  * 'TCEforms' - Class for creating the backend editing forms.
  *
Index: t3lib/class.t3lib_svbase.php
===================================================================
--- t3lib/class.t3lib_svbase.php	(Revision 5109)
+++ t3lib/class.t3lib_svbase.php	(Arbeitskopie)
@@ -108,7 +108,6 @@
 // define ('T3_ERR_SV_serviceType_myerr, -100); // All errors with prefix T3_ERR_SV_[serviceType]_ and lower than -99 are service type dependent error
 
 
-require_once(PATH_t3lib.'class.t3lib_exec.php');
 
 
 
@@ -375,8 +374,6 @@
 	function checkExec($progList) {
 		$ret = TRUE;
 
-		require_once(PATH_t3lib.'class.t3lib_exec.php');
-
 		$progList = t3lib_div::trimExplode(',', $progList, 1);
 		foreach($progList as $prog) {
 			if (!t3lib_exec::checkCommand($prog)) {
Index: t3lib/class.t3lib_sqlengine.php
===================================================================
--- t3lib/class.t3lib_sqlengine.php	(Revision 5109)
+++ t3lib/class.t3lib_sqlengine.php	(Arbeitskopie)
@@ -89,7 +89,6 @@
 
 
 
-require_once(PATH_t3lib.'class.t3lib_sqlparser.php');
 
 
 /**
Index: t3lib/class.t3lib_pagetree.php
===================================================================
--- t3lib/class.t3lib_pagetree.php	(Revision 5109)
+++ t3lib/class.t3lib_pagetree.php	(Arbeitskopie)
@@ -64,7 +64,6 @@
 
 
 
-require_once (PATH_t3lib.'class.t3lib_treeview.php');
 
 /**
  * Class for generating a page tree.
Index: t3lib/class.t3lib_tsstyleconfig.php
===================================================================
--- t3lib/class.t3lib_tsstyleconfig.php	(Revision 5109)
+++ t3lib/class.t3lib_tsstyleconfig.php	(Arbeitskopie)
@@ -57,7 +57,6 @@
  *
  */
 
-require_once(PATH_t3lib.'class.t3lib_tsparser_ext.php');
 
 
 
Index: t3lib/class.t3lib_extmgm.php
===================================================================
--- t3lib/class.t3lib_extmgm.php	(Revision 5109)
+++ t3lib/class.t3lib_extmgm.php	(Arbeitskopie)
@@ -829,8 +829,6 @@
 
 						// service depends on external programs - check if they exists
 					if(trim($info['exec'])) {
-						require_once(PATH_t3lib.'class.t3lib_exec.php');
-
 						$executables = t3lib_div::trimExplode(',', $info['exec'], 1);
 						foreach($executables as $executable) {
 							if(!t3lib_exec::checkCommand($executable)) {
Index: t3lib/class.t3lib_install.php
===================================================================
--- t3lib/class.t3lib_install.php	(Revision 5109)
+++ t3lib/class.t3lib_install.php	(Arbeitskopie)
@@ -71,7 +71,6 @@
 
 
 
-require_once(PATH_t3lib.'class.t3lib_sqlparser.php');
 
 /**
  * Class to setup values in localconf.php and verify the TYPO3 DB tables/fields
Index: t3lib/class.t3lib_transferdata.php
===================================================================
--- t3lib/class.t3lib_transferdata.php	(Revision 5109)
+++ t3lib/class.t3lib_transferdata.php	(Arbeitskopie)
@@ -73,10 +73,6 @@
  */
 
 
-require_once (PATH_t3lib.'class.t3lib_loaddbgroup.php');
-require_once (PATH_t3lib.'class.t3lib_loadmodules.php');
-require_once (PATH_t3lib.'class.t3lib_parsehtml_proc.php');
-require_once (PATH_t3lib.'class.t3lib_flexformtools.php');
 
 
 
Index: t3lib/class.t3lib_browsetree.php
===================================================================
--- t3lib/class.t3lib_browsetree.php	(Revision 5109)
+++ t3lib/class.t3lib_browsetree.php	(Arbeitskopie)
@@ -49,7 +49,6 @@
  *
  */
 
-require_once (PATH_t3lib.'class.t3lib_treeview.php');
 
 
 
Index: t3lib/class.t3lib_tstemplate.php
===================================================================
--- t3lib/class.t3lib_tstemplate.php	(Revision 5109)
+++ t3lib/class.t3lib_tstemplate.php	(Arbeitskopie)
@@ -80,8 +80,6 @@
  *
  */
 
-require_once (PATH_t3lib.'class.t3lib_tsparser.php');
-require_once (PATH_t3lib.'class.t3lib_matchcondition.php');
 
 
 
Index: t3lib/class.t3lib_frontendedit.php
===================================================================
--- t3lib/class.t3lib_frontendedit.php	(Revision 5109)
+++ t3lib/class.t3lib_frontendedit.php	(Arbeitskopie)
@@ -109,16 +109,8 @@
 		if (($this->isAdminModuleEnabled('edit') && $this->isAdminModuleOpen('edit')) || $GLOBALS['TSFE']->displayEditIcons == 1) {
 			$GLOBALS['TSFE']->includeTCA();
 			if ($this->isEditAction()) {
-				require_once (PATH_t3lib . 'class.t3lib_tcemain.php');
 				$this->editAction();
 			}
-
-			if ($this->isEditFormShown()) {
-				require_once(PATH_t3lib . 'class.t3lib_tceforms.php');
-				require_once(PATH_t3lib . 'class.t3lib_iconworks.php');
-				require_once(PATH_t3lib . 'class.t3lib_loaddbgroup.php');
-				require_once(PATH_t3lib . 'class.t3lib_transferdata.php');
-			}
 		}
 
 		if ($GLOBALS['TSFE']->forceTemplateParsing || $GLOBALS['TSFE']->displayEditIcons || $GLOBALS['TSFE']->displayFieldEditIcons) {
Index: t3lib/class.t3lib_treeview.php
===================================================================
--- t3lib/class.t3lib_treeview.php	(Revision 5109)
+++ t3lib/class.t3lib_treeview.php	(Arbeitskopie)
@@ -98,9 +98,6 @@
 
 
 
-require_once (PATH_t3lib.'class.t3lib_iconworks.php');
-require_once (PATH_t3lib.'class.t3lib_befunc.php');
-require_once (PATH_t3lib.'class.t3lib_div.php');
 
 
 /**
Index: t3lib/class.t3lib_tceforms_fe.php
===================================================================
--- t3lib/class.t3lib_tceforms_fe.php	(Revision 5109)
+++ t3lib/class.t3lib_tceforms_fe.php	(Arbeitskopie)
@@ -49,7 +49,6 @@
  * @author	Kasper Skaarhoj <kasperYYYY@typo3.com>
  */
 
-require_once(PATH_t3lib . 'class.t3lib_tceforms.php');
 
 
 /**
Index: t3lib/class.t3lib_softrefproc.php
===================================================================
--- t3lib/class.t3lib_softrefproc.php	(Revision 5109)
+++ t3lib/class.t3lib_softrefproc.php	(Arbeitskopie)
@@ -94,7 +94,6 @@
  */
 
 
-require_once(PATH_t3lib.'class.t3lib_parsehtml.php');
 
 /**
  * Class for processing of the default soft reference types for CMS:
Index: t3lib/class.t3lib_loaddbgroup.php
===================================================================
--- t3lib/class.t3lib_loaddbgroup.php	(Revision 5109)
+++ t3lib/class.t3lib_loaddbgroup.php	(Arbeitskopie)
@@ -62,7 +62,6 @@
 
 
 
-require_once (PATH_t3lib.'class.t3lib_refindex.php');
 
 
 
Index: t3lib/class.t3lib_befunc.php
===================================================================
--- t3lib/class.t3lib_befunc.php	(Revision 5109)
+++ t3lib/class.t3lib_befunc.php	(Arbeitskopie)
@@ -171,7 +171,6 @@
  *
  */
 
-require_once (PATH_t3lib.'class.t3lib_loaddbgroup.php');
 
 
 /**
Index: t3lib/class.t3lib_cache.php
===================================================================
--- t3lib/class.t3lib_cache.php	(Revision 5109)
+++ t3lib/class.t3lib_cache.php	(Arbeitskopie)
@@ -22,7 +22,6 @@
 *  This copyright notice MUST APPEAR in all copies of the script!
 ***************************************************************/
 
-require_once(PATH_t3lib . 'interfaces/interface.t3lib_singleton.php');
 
 /**
  * A cache handling helper class
Index: t3lib/class.t3lib_tceforms_inline.php
===================================================================
--- t3lib/class.t3lib_tceforms_inline.php	(Revision 5109)
+++ t3lib/class.t3lib_tceforms_inline.php	(Arbeitskopie)
@@ -88,7 +88,6 @@
  *
  */
 
-require_once(PATH_t3lib.'class.t3lib_parsehtml.php');
 
 class t3lib_TCEforms_inline {
 
@@ -998,8 +997,6 @@
 		global $SOBE, $BE_USER, $TYPO3_CONF_VARS;
 
 		require_once(PATH_typo3.'template.php');
-		require_once(PATH_t3lib.'class.t3lib_tceforms.php');
-		require_once(PATH_t3lib.'class.t3lib_clipboard.php');
 
 		$GLOBALS['LANG']->includeLLFile('EXT:lang/locallang_alt_doc.xml');
 
Index: t3lib/class.t3lib_lock.php
===================================================================
--- t3lib/class.t3lib_lock.php	(Revision 5109)
+++ t3lib/class.t3lib_lock.php	(Arbeitskopie)
@@ -32,7 +32,6 @@
  * @author	Michael Stucki <michael@typo3.org>
  */
 
-require_once(PATH_t3lib.'class.t3lib_div.php');
 
 
 
Index: t3lib/class.t3lib_userauthgroup.php
===================================================================
--- t3lib/class.t3lib_userauthgroup.php	(Revision 5109)
+++ t3lib/class.t3lib_userauthgroup.php	(Arbeitskopie)
@@ -99,8 +99,6 @@
  *
  */
 
-	// Need this for parsing User TSconfig
-require_once (PATH_t3lib.'class.t3lib_tsparser.php');
 
 
 
Index: t3lib/class.t3lib_tcemain.php
===================================================================
--- t3lib/class.t3lib_tcemain.php	(Revision 5109)
+++ t3lib/class.t3lib_tcemain.php	(Arbeitskopie)
@@ -205,15 +205,6 @@
 
 
 
-// *******************************
-// Including necessary libraries
-// *******************************
-require_once (PATH_t3lib.'class.t3lib_loaddbgroup.php');
-require_once (PATH_t3lib.'class.t3lib_parsehtml_proc.php');
-require_once (PATH_t3lib.'class.t3lib_stdgraphic.php');
-require_once (PATH_t3lib.'class.t3lib_basicfilefunc.php');
-require_once (PATH_t3lib.'class.t3lib_refindex.php');
-require_once (PATH_t3lib.'class.t3lib_flexformtools.php');
 
 
 
Index: t3lib/class.t3lib_parsehtml_proc.php
===================================================================
--- t3lib/class.t3lib_parsehtml_proc.php	(Revision 5109)
+++ t3lib/class.t3lib_parsehtml_proc.php	(Arbeitskopie)
@@ -80,7 +80,6 @@
  *
  */
 
-require_once (PATH_t3lib.'class.t3lib_parsehtml.php');
 
 
 
Index: t3lib/class.t3lib_tsparser_ext.php
===================================================================
--- t3lib/class.t3lib_tsparser_ext.php	(Revision 5109)
+++ t3lib/class.t3lib_tsparser_ext.php	(Arbeitskopie)
@@ -87,7 +87,6 @@
  *
  */
 
-require_once(PATH_t3lib.'class.t3lib_tstemplate.php');
 
 
 
Index: t3lib/class.t3lib_extobjbase.php
===================================================================
--- t3lib/class.t3lib_extobjbase.php	(Revision 5109)
+++ t3lib/class.t3lib_extobjbase.php	(Arbeitskopie)
@@ -112,7 +112,6 @@
  *
  * Anyways, the final interesting thing is to see what the framework "func_wizard" actually does:
  *
- * 	require_once(PATH_t3lib."class.t3lib_extobjbase.php");
  * 	class tx_funcwizards_webfunc extends t3lib_extobjbase {
  * 		var $localLangFile = "locallang.php";
  * 		var $function_key = "wiz";