Index: t3lib/cache/class.t3lib_cache_abstractcache.php
===================================================================
--- t3lib/cache/class.t3lib_cache_abstractcache.php	(Revision 4426)
+++ t3lib/cache/class.t3lib_cache_abstractcache.php	(Arbeitskopie)
@@ -93,7 +93,7 @@
 	 * @return void
 	 * @author Robert Lemke <robert@typo3.org>
 	 */
-	abstract public function save($entryIdentifier, $data, array $tags = array(), $lifetime = null);
+	abstract public function set($entryIdentifier, $data, array $tags = array(), $lifetime = null);
 
 	/**
 	 * Loads data from the cache.
@@ -102,7 +102,7 @@
 	 * @return mixed
 	 * @author Robert Lemke <robert@typo3.org>
 	 */
-	abstract public function load($entryIdentifier);
+	abstract public function get($entryIdentifier);
 
 	/**
 	 * Finds, loads, and returns all cache entries which are tagged by the specified tag.
@@ -113,12 +113,12 @@
 	 * @return array An array with all matching entries. An empty array if no entries matched
 	 * @author Ingo Renner <ingo@typo3.org>
 	 */
-	public function loadByTag($tag) {
+	public function getByTag($tag) {
 		$loadedEntries = array();
 		$foundEntries  = $this->findEntriesByTag($tag);
 
 		foreach($foundEntries as $foundEntryIdentifier) {
-			$loadedEntries[$foundEntryIdentifier] = $this->load($foundEntryIdentifier);
+			$loadedEntries[$foundEntryIdentifier] = $this->get($foundEntryIdentifier);
 		}
 
 		return $loadedEntries;
Index: t3lib/cache/class.t3lib_cache_variablecache.php
===================================================================
--- t3lib/cache/class.t3lib_cache_variablecache.php	(Revision 4426)
+++ t3lib/cache/class.t3lib_cache_variablecache.php	(Arbeitskopie)
@@ -44,8 +44,8 @@
 	 * @return void
 	 * @author Robert Lemke <robert@typo3.org>
 	 */
-	public function save($entryIdentifier, $variable, array $tags = array(), $lifetime = null) {
-		$this->backend->save($entryIdentifier, serialize($variable), $tags, $lifetime);
+	public function set($entryIdentifier, $variable, array $tags = array(), $lifetime = null) {
+		$this->backend->set($entryIdentifier, serialize($variable), $tags, $lifetime);
 	}
 
 	/**
@@ -56,8 +56,8 @@
 	 * @author Robert Lemke <robert@typo3.org>
 	 * @throws t3lib_cache_exception_ClassAlreadyLoaded if the class already exists
 	 */
-	public function load($entryIdentifier) {
-		return unserialize($this->backend->load($entryIdentifier));
+	public function get($entryIdentifier) {
+		return unserialize($this->backend->get($entryIdentifier));
 	}
 
 	/**
Index: t3lib/cache/backend/class.t3lib_cache_backend_file.php
===================================================================
--- t3lib/cache/backend/class.t3lib_cache_backend_file.php	(Revision 4426)
+++ t3lib/cache/backend/class.t3lib_cache_backend_file.php	(Arbeitskopie)
@@ -126,7 +126,7 @@
 	 * @throws t3lib_cache_Exception if the directory does not exist or is not writable, or if no cache frontend has been set.
 	 * @author Robert Lemke <robert@typo3.org>
 	 */
-	public function save($entryIdentifier, $data, array $tags = array(), $lifetime = NULL) {
+	public function set($entryIdentifier, $data, array $tags = array(), $lifetime = NULL) {
 		if (!self::isValidEntryIdentifier($entryIdentifier)) {
 			throw new InvalidArgumentException(
 				'"' . $entryIdentifier . '" is not a valid cache entry identifier.',
@@ -232,7 +232,7 @@
 	 * @return mixed The cache entry's content as a string or FALSE if the cache entry could not be loaded
 	 * @author Robert Lemke <robert@typo3.org>
 	 */
-	public function load($entryIdentifier) {
+	public function get($entryIdentifier) {
 		$pathsAndFilenames = $this->findCacheFilesByEntry($entryIdentifier);
 		$cacheEntry        = FALSE;
 
Index: t3lib/cache/backend/class.t3lib_cache_backend_globals.php
===================================================================
--- t3lib/cache/backend/class.t3lib_cache_backend_globals.php	(Revision 4426)
+++ t3lib/cache/backend/class.t3lib_cache_backend_globals.php	(Arbeitskopie)
@@ -68,7 +68,7 @@
 	 * @throws t3lib_cache_Exception if the directory does not exist or is not writable, or if no cache frontend has been set.
 	 * @author Ingo Renner <ingo@typo3.org>
 	 */
-	public function save($entryIdentifier, $data, array $tags = array(), $lifetime = NULL) {
+	public function set($entryIdentifier, $data, array $tags = array(), $lifetime = NULL) {
 		if (!self::isValidEntryIdentifier($entryIdentifier)) {
 			throw new InvalidArgumentException(
 				'"' . $entryIdentifier . '" is not a valid cache entry identifier.',
@@ -120,7 +120,7 @@
 	 * @return mixed The cache entry's content as a string or FALSE if the cache entry could not be loaded
 	 * @author Ingo Renner <ingo@typo3.org>
 	 */
-	public function load($entryIdentifier) {
+	public function get($entryIdentifier) {
 		$cacheEntry = FALSE;
 
 		if (isset($GLOBALS['typo3CacheStorage'][$this->cache->getIdentifier()]['data'][$entryIdentifier])) {
Index: t3lib/cache/backend/class.t3lib_cache_backend_db.php
===================================================================
--- t3lib/cache/backend/class.t3lib_cache_backend_db.php	(Revision 4426)
+++ t3lib/cache/backend/class.t3lib_cache_backend_db.php	(Arbeitskopie)
@@ -45,7 +45,7 @@
 	 * @throws t3lib_cache_Exception if the directory does not exist or is not writable, or if no cache frontend has been set.
 	 * @author Ingo Renner <ingo@typo3.org>
 	 */
-	public function save($entryIdentifier, $data, array $tags = array(), $lifetime = NULL) {
+	public function set($entryIdentifier, $data, array $tags = array(), $lifetime = NULL) {
 		if (is_null($lifetime)) {
 			$lifetime = $this->defaultLifetime;
 		}
@@ -71,7 +71,7 @@
 	 * @return mixed The cache entry's data as a string or FALSE if the cache entry could not be loaded
 	 * @author Ingo Renner <ingo@typo3.org>
 	 */
-	public function load($entryIdentifier) {
+	public function get($entryIdentifier) {
 		$cacheEntry = false;
 
 		$caheEntries = $GLOBALS['TYPO3_DB']->exec_SELECTgetRows(
Index: t3lib/class.t3lib_tstemplate.php
===================================================================
--- t3lib/class.t3lib_tstemplate.php	(Revision 4426)
+++ t3lib/class.t3lib_tstemplate.php	(Arbeitskopie)
@@ -257,7 +257,7 @@
 		$pageSectionCache = $GLOBALS['typo3CacheManager']->getCache('cache_pagesection');
 		/* @var $pageSectionCache t3lib_cache_AbstractCache */
 
-		$cacheEntry = $pageSectionCache->load(
+		$cacheEntry = $pageSectionCache->get(
 			intval($GLOBALS['TSFE']->id) . '_' . t3lib_div::md5int($GLOBALS['TSFE']->MP)
 		);
 
@@ -398,7 +398,7 @@
 
 				$mpvarHash = t3lib_div::md5int($GLOBALS['TSFE']->MP);
 
-				$pageSectionCache->save(
+				$pageSectionCache->set(
 					intval($GLOBALS['TSFE']->id) . '_' . $mpvarHash,
 					serialize($cc),
 					array(
Index: t3lib/class.t3lib_befunc.php
===================================================================
--- t3lib/class.t3lib_befunc.php	(Revision 4426)
+++ t3lib/class.t3lib_befunc.php	(Arbeitskopie)
@@ -1210,7 +1210,7 @@
 	 * @return	void
 	 */
 	public static function storeHash($hash, $data, $ident) {
-		$GLOBALS['typo3CacheManager']->getCache('cache_hash')->save(
+		$GLOBALS['typo3CacheManager']->getCache('cache_hash')->set(
 			$hash,
 			$data,
 			array('ident_' . $ident),
@@ -1231,7 +1231,7 @@
 		$hashContent = null;
 
 		$contentHashCache = $GLOBALS['typo3CacheManager']->getCache('cache_hash');
-		$cacheEntry = $contentHashCache->load($hash);
+		$cacheEntry = $contentHashCache->get($hash);
 
 		if ($cacheEntry) {
 			$hashContent = $cacheEntry;
Index: t3lib/class.t3lib_page.php
===================================================================
--- t3lib/class.t3lib_page.php	(Revision 4426)
+++ t3lib/class.t3lib_page.php	(Arbeitskopie)
@@ -942,7 +942,7 @@
 		$hashContent = null;
 
 		$contentHashCache = $GLOBALS['typo3CacheManager']->getCache('cache_hash');
-		$cacheEntry = $contentHashCache->load($hash);
+		$cacheEntry = $contentHashCache->get($hash);
 
 		if ($cacheEntry) {
 			$hashContent = $cacheEntry;
@@ -964,7 +964,7 @@
 	 * @see tslib_TStemplate::start(), getHash()
 	 */
 	public static function storeHash($hash, $data, $ident, $lifetime = 0) {
-		$GLOBALS['typo3CacheManager']->getCache('cache_hash')->save(
+		$GLOBALS['typo3CacheManager']->getCache('cache_hash')->set(
 			$hash,
 			$data,
 			array('ident_' . $ident),
Index: typo3/sysext/cms/tslib/class.tslib_fe.php
===================================================================
--- typo3/sysext/cms/tslib/class.tslib_fe.php	(Revision 4426)
+++ typo3/sysext/cms/tslib/class.tslib_fe.php	(Arbeitskopie)
@@ -1896,7 +1896,7 @@
 	 */
 	function getFromCache_queryRow() {
 		$GLOBALS['TT']->push('Cache Query', '');
-		$cachedPage = $this->pageCache->load($this->newHash);
+		$cachedPage = $this->pageCache->get($this->newHash);
 		$GLOBALS['TT']->pull();
 
 		return $cachedPage;
@@ -2715,7 +2715,7 @@
 			$this->pageCacheTags[] = 'reg1_' . $reg1;
 		}
 
-		$this->pageCache->save(
+		$this->pageCache->set(
 			$cacheData['hash'],
 			$cacheData,
 			$this->pageCacheTags,